import { ElementRef, EventEmitter, OnChanges } from '@angular/core';
import * as SimplePickerModels from './angular-simple-date-picker.model';
export declare class AngularSimpleDatePickerComponent implements OnChanges {
    private elmRef;
    /**
     * Property declarations
     */
    dates: Array<SimplePickerModels.CalendarDate>;
    dayNames: string[];
    monthList: Array<SimplePickerModels.MonthListItem>;
    activeDate: any;
    selectedDate: any;
    showMonthSelector: boolean;
    showYearSelector: boolean;
    initialDate: any;
    visible: boolean;
    private closeEnabled;
    /**
     * Input & Output declarations
     */
    importantDates: Array<any>;
    date: string;
    inputClass: string;
    dateChange: EventEmitter<string>;
    /**
     * Events
     */
    clickInside(event: any): void;
    /**
     * Component constructor
     */
    constructor(elmRef: ElementRef);
    /**
     * Getters & setters
     */
    /**
     * Lifecycle hooks
     */
    ngOnChanges(): void;
    onClick(event: any): boolean;
    /**
     * Component Methods
     */
    setSelected(date: any): boolean;
    closePicker(): void;
    setDate(date: any): void;
    closeMonthSelector(evt: any): void;
    closeYearSelector(evt: any): void;
    updateMonth(evt: any): void;
    updateYear(evt: any): void;
    getActiveDate(date?: any): {
        month: string;
        year: string;
    };
    getPrevMonth(): void;
    getNextMonth(): void;
    private buildActiveDate;
    private setActiveDate;
    private setOffset;
    private generateMonthList;
    private generateCalendar;
}
